/* mpTree 0.1.2
 * -----------[ http://mptree.netpedia.net
 *
 *   Use this software at your own risk!
 *    This software falls under the GPL.
 *   Read COPYING for further informations.
 */

#include <signal.h>
#include <sys/wait.h>

#include "mptree.h"

#include "icons/artist.xpm"
#include "icons/album1.xpm"
#include "icons/song1.xpm"
#include "icons/database.xpm"

	//Globals

GtkWidget *addfileswin, *statusbar, *box, *mainwin;
GtkWidget *writing_setup_widget, *writing_widget, *about_box;
GtkWidget *artisticon, *albumicon, *songicon, *dbicon;
GtkWidget *ctree;
GtkWidget *pathentry, *mediumentry;
GtkCTreeNode *root, *sndt_root=NULL, *selected_tree_item, *av_root = NULL;
int cdr_o[2];
FILE *cdrecord_out;

char *NO_ARTIST = "<no artist>";
char *NO_ALBUM = "<non-album-tracks>";
char *NO_TITLE = "<untitled>";
char *SNDTRACKS = "<soundtracks/compilations>";
// char SORT_RECURSIVE=FALSE;
// char SORT_SNDTRACKS=TRUE;
char *NAMED_PIPE="/root/.gqmpeg/command";
float MAX_PERCENT = 70;

unsigned short max_row_medialist = -1;	// => no db in memory!
unsigned short songlist_count = 0;
char message[255];
float media_size;		// size of (added) media in MB
unsigned int media_sl;		// total songlength in seconds of (added) media
unsigned int selected_medium=-1, selected_slitem=-1;

	//End of Globals

int main(int argc, char *argv[])
{
    GtkWidget *medialisttab;
    GtkWidget *treetab, *list;
    GtkWidget *notebook, *nblabel;

    gtk_init(&argc, &argv);
    mainwin = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW(mainwin), "mpTree");
    gtk_window_set_default_size(GTK_WINDOW(mainwin), 320, 430);
    gtk_signal_connect(GTK_OBJECT(mainwin), "delete_event",
                       GTK_SIGNAL_FUNC(gtk_main_quit), &mainwin);

    box = gtk_vbox_new(FALSE, 0);

    create__menubar();
    create__toolbar();

    treetab = gtk_scrolled_window_new(NULL, NULL);
    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW(treetab), 
      GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
    ctree = gtk_ctree_new(1, 0);

    notebook = gtk_notebook_new();
    gtk_signal_connect(GTK_OBJECT(notebook), "switch_page",
                       GTK_SIGNAL_FUNC(notebook_page_switched), &mainwin);
    nblabel = gtk_label_new("Database");
    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), treetab, nblabel);

    medialisttab = gtk_frame_new("Media");
    list = gtk_frame_new("internal List");
    gtk_frame_set_shadow_type( GTK_FRAME(medialisttab), GTK_SHADOW_ETCHED_OUT);
    gtk_frame_set_shadow_type( GTK_FRAME(list), GTK_SHADOW_ETCHED_OUT);
    create__medialist(medialisttab);
    create__symbols();
    create__tree(treetab);
    create__list(list);

    nblabel = gtk_label_new("MediaList");
    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), medialisttab, nblabel);

    nblabel = gtk_label_new("SongList");
    gtk_notebook_append_page(GTK_NOTEBOOK(notebook), list, nblabel);

    gtk_box_pack_start(GTK_BOX(box), notebook, TRUE, TRUE, TRUE);

    statusbar = gtk_statusbar_new();
    gtk_box_pack_start(GTK_BOX(box), statusbar, FALSE, FALSE, TRUE);

    gtk_container_add(GTK_CONTAINER(mainwin), box);
    gtk_widget_show_all(mainwin);
    gtk_main();

    exit_appl();
    exit(0);
}

void create__symbols()
{
//    GdkPixmap *artistpixmap, *albumpixmap, *songpixmap, *dbpixmap;
    GdkBitmap *bitmap;
    GtkStyle *style;
    
    style=gtk_widget_get_style(ctree);
    dbpixmap = gdk_pixmap_create_from_xpm_d(mainwin->window, &bitmap, &style->bg[GTK_STATE_NORMAL], (gchar **) db_icon_xpm);
    dbicon = gtk_pixmap_new(dbpixmap, bitmap);
    artistpixmap = gdk_pixmap_create_from_xpm_d(mainwin->window, &bitmap, &style->bg[GTK_STATE_NORMAL], (gchar **) artist_icon_xpm);
    artisticon = gtk_pixmap_new(artistpixmap, bitmap);
    albumpixmap = gdk_pixmap_create_from_xpm_d(mainwin->window, &bitmap, &style->bg[GTK_STATE_NORMAL], (gchar **) album_icon_xpm);
    albumicon = gtk_pixmap_new(albumpixmap, bitmap);
    songpixmap = gdk_pixmap_create_from_xpm_d(mainwin->window, &bitmap, &style->bg[GTK_STATE_NORMAL], (gchar **) song_icon_xpm);
    songicon = gtk_pixmap_new(songpixmap, bitmap);
}

void notebook_page_switched(GtkNotebook *nb, GtkWidget *widget, int page) 
/* unsure about *widget, but gtk-documentation (1.2) didn't have any 
 * informations about GtkNotebook's signals
 */
{
    disable_mb_items(page);
    disable_tb_items(page);
    if (page==0)
    {
       gtk_widget_hide(ctree);  
       gtk_widget_show(ctree);
    }

    else if (page==1)
    {
       extern GtkWidget *media_list;

       gtk_widget_hide(media_list);
       gtk_widget_show(media_list);
    }
    else if (page==2)
    {
       extern GtkWidget *songList;

       gtk_widget_hide(songList);  //hiding and unhiding the widget 
       gtk_widget_show(songList);  //fixes add-items-bug. why?? (other ways?)
    }    
}

void exit_appl()
{
    gtk_exit(0);
}
